﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
'Custom View class
'#LibraryVersion:1
'#LibraryAuthor:MagickTurk
'#LibraryName:JAutoUpdate

'#Event: Example2Event (Value As Int, Test as String)
'#Event: Resize (Width As Double, Height As Double)
#Event: DownloadError (info as String)
#Event: DownloadComplete (TempFolder as String, TempFile as String)
#Event: CheckingResult (Success as Boolean, updatetype as String)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private Target_File As String
	Private Target_Ext As String
	Private Target_Ver As String
	Private Real_File As String
	Private Folder_LAN As String
	Private Folder_WEB As String
	Private Folder_FTP As String
	Private MainLimit As Int
	Private FractionLimit As Int
	Private Logger As Boolean
	Private V1,V2 As Int
	Public isDownloadComplete As Boolean
	Private FTP As FTP
	Private FTPport As Int
	Private FTPuser, FTPpsw ,FTPserver As String
End Sub

'<code>
'autoupdate.Initialize(Me,"autoupdate")
'</code>
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	Target_File=""
	Target_Ext=""
	Target_Ver=""
	Real_File=""
	Folder_LAN=""
	Folder_WEB=""
	Folder_FTP=""
	FTPport=0
	FTPuser=""
	FTPpsw=""
	FTPserver=""
	MainLimit=9
	FractionLimit=9
	Logger=False
	V1=0
	V2=0
	isDownloadComplete=False

End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub




Private Sub DownloadWEB(webfolder As String,webfile As String, version As String, webfileext As String)
	Dim xui As XUI
	Dim v As String=""
	Dim job As HttpJob
	Dim z1,z2 As Int
	z1=webmajor(version)
	z2=webminor(version)
	If z2+1>FractionLimit Then
		z2=0
		z1=z1+1
	Else
		z2=z2+1
	End If
	If (z1*FractionLimit+z2)-(V1*FractionLimit+V2)>20 Then
		'cancel all downlaods
		isDownloadComplete=False
		If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
			CallSubDelayed2(mCallBack,mEventName & "_DownloadError","Jautodownload lib. tried 20 times /20 diffrent version, therefore cancelled")
		End If
		Return
	Else
		If MainLimit<V1 Then
			'cancel all downlaods
			isDownloadComplete=False
			If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
				CallSubDelayed2(mCallBack,mEventName & "_DownloadError","Jautodownload lib. latest download version bigger than main varsion limit,therefore cancelled")
			End If
			Return
		End If
	End If
	
	
	v=z1&"."&z2
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.JobName=webfile
	job.Tag=v
	AppLog(webfolder&"/"&webfile&"_"&v&"."&webfileext)
	job.Download(webfolder&"/"&webfile&"_"&v&"."&webfileext)
	job.GetRequest.Timeout = 10000
End Sub


Private Sub JobDone(job As HttpJob)
	Dim xui As XUI
	If job.Success Then
		
		AppLog("Downloaded :"&job.JobName)
		Dim x(job.GetInputStream.BytesAvailable) As Byte
		job.GetInputStream.ReadBytes(x,0,x.Length)
		File.WriteBytes(File.DirApp&"\temp_update", Target_File&".tmp",x)
		job.Release
		
		Dim TempFolder As String=File.DirApp&"\temp_update"
		Dim TempFile As String=Target_File&".tmp"
		isDownloadComplete=True
		If xui.SubExists(mCallBack, mEventName & "_DownloadComplete",0) Then
			CallSubDelayed3(mCallBack,mEventName & "_DownloadComplete",TempFolder,TempFile)
		End If
		
	Else
		job.Release
		AppLog(job.ErrorMessage)
		Dim c As String=job.Tag
		DownloadWEB(Folder_WEB,Target_File,c,Target_Ext)
	End If
End Sub


'Version : (only number and point) Own app verision. Code find upper version on WEB destination, if You use empty; The program checks the file dates. It works if the file in the destination is newer.
'FileName: its file name on destination folder. it s not inculded file extension
'FileExtension: its need for cheking file name.
'SourceFolder : Source folder on web.
'Note: be careful, have big and small character sensitivity.
'<code>
''** for example https://upload.wikimedia.org/wikipedia/tr/0/0c/Choqok_1.2.png
''** target file has "_" between filename & version number.
'autoupdate.Initialize(Me,"autoupdate")
'autoupdate.UseWEB(MainForm,"1.1","Choqok","png","https://upload.wikimedia.org/wikipedia/tr/0/0c")
'</code>
Public Sub UseWEB (AnaForm As Form,	Version As String,FileName As String,FileExtension  As String,SourceFolder As String)
	mBase = AnaForm.RootPane
	Target_Ver=Version.ToLowerCase.Trim
	Target_File= FileName.Trim
	Target_Ext=FileExtension.Trim
	Folder_WEB=SourceFolder.Trim
	veriyoncoz(Target_Ver)
	AppLog("Temp files deleting:"&DeleteFolder(File.DirApp&"\temp_update"))

End Sub

Public Sub IsInitializedWEB As Boolean
	If Target_File.Trim= "" Then
		AppLog("JAutoUpdate >> "&" Target file is empty")
		Return False
	End If
	
	If Target_Ext="" Then
		AppLog("JAutoUpdate >> "&" Extension file is empty")
		Return False
	End If
	If Folder_WEB="" Then
		AppLog("JAutoUpdate >> "&" Folder data is empty")
		Return False
	End If
	If Target_Ver.Trim= "" Then
		AppLog("JAutoUpdate >> "&" Target version is empty")
		Return False
	End If
	Return True
End Sub

'start download process
'<code>
'Sub autoupdate_CheckingResult (Success As Boolean, updatetype As String)
'	If Success Then
'		If fx.Msgbox2(MainForm, "Do you want to download new version?", "Found new version", "Yes", "Cancel", "No",fx.MSGBOX_CONFIRMATION) = fx.DialogResponse.POSITIVE Then
'			Log("starting download... ")
'			
'			Select updatetype
'				Case "FTP"
'					autoupdate.StartDownlaodFTP
'				Case "LAN"
'					autoupdate.StartDownlaodLAN
'				Case "WEB"
'					autoupdate.StartDownlaodWEB
'				Case Else
'					Log("ERROR")
'			End Select
'		End If
'	Else
'		Log("No new verisyon...")
'	End If
'End Sub
'</code>
Public Sub StartDownlaodWEB
	Try
		Dim xui As XUI
		File.MakeDir(File.DirApp,"temp_update")
		Wait For (File.CopyAsync(File.DirAssets, "autoupdate.jar", File.DirApp&"\temp_update", "autoupdate.jar")) Complete (Success As Boolean)

		If Success Then
			DownloadWEB(Folder_WEB,Target_File,Target_Ver,Target_Ext)
		Else
			isDownloadComplete=False
			If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
				CallSubDelayed2(mCallBack,mEventName & "_DownloadError","Jautodownload lib. can not create downloader, please try again")
			End If
		End If
	Catch
		AppLog("Error StartDownloadWeb Process:"&LastException)
		isDownloadComplete=False
		If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
			CallSubDelayed2(mCallBack,mEventName & "_DownloadError",LastException)
		End If
	End Try
	
End Sub

'it s cheking web connection with target web site
Public Sub CheckingWEB 
	Dim xui As XUI
	Try
		'Dim w As OkHttpClient
		Dim inetaddress As JavaObject
		inetaddress.InitializeStatic("java.net.InetAddress")
		Dim x As String=Folder_WEB
		x=x.Replace("https://","").Replace("http://","").Replace("HTTPS://","").Replace("HTTP://","")
		Dim components() As String
		components = Regex.Split("/", x) 'returns: "abc", "def", "", "ghi"
		
		If inetaddress.RunMethodJO("getByName",Array As String(components(0))).RunMethod("isReachable",Array As Object(2000)) Then
			AppLog(components(0)&" is reachable")
			If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
				CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",True,"WEB")
			End If
			Return
		Else
			AppLog(components(0)&" is unreachable")
			If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
				CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"WEB")
			End If
			Return
		End If
	
	Catch
		AppLog(LastException)
		If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
			CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"WEB")
		End If
		Return
	End Try
	
End Sub

Private Sub RenameTo(DirName As String, FileName As String, NewDirName As String, NewFileName As String) As Boolean
	
	Try
		Dim Source As JavaObject
		Source.InitializeNewInstance("java.io.File",Array(DirName,FileName))
		Dim Dest As JavaObject
		Dest.InitializeNewInstance("java.io.File",Array(NewDirName,NewFileName))
		Return Source.RunMethod("renameTo",Array As Object(Dest))
	Catch
		AppLog(LastException)
		Return False
	End Try
	
End Sub

'dosyanın nezaman kayıt edildiğini gösterir..
Private Sub FileLastModified(Folder_nm As String, File_nm As String) As Long

	If File.Exists(Folder_nm,File_nm) Then
		Return File.LastModified(Folder_nm,File_nm)
	Else
		Return 0
	End If
End Sub



'Version : (only number and point) Own app verision. Code find upper version on LAN destination, if You use empty; The program checks the file dates. It works if the file in the destination is newer.
'FileName: its file name on destination folder. it s not inculded file extension
'FileExtension: its need for cheking file name.
'SourceFolder : Source folder on lan.
'<code>
''** for example \\192.168.1.31\app\new\test_1.5.jar
''** target file has "_" between filename & version number.
'autoupdate.Initialize(Me,"autoupdate")
'autoupdate.UseLan(MainForm,"1.2","test","jar","\\192.168.1.31\app\new")
'</code>
Public Sub UseLan (AnaForm As Form,	Version As String,FileName As String,FileExtension  As String,SourceFolder As String)
	mBase = AnaForm.RootPane
	Target_Ver=Version.ToLowerCase
	Target_File= FileName.ToLowerCase
	Target_Ext=FileExtension.ToLowerCase
	Folder_LAN=SourceFolder.ToLowerCase
	veriyoncoz(Target_Ver)
	AppLog("Temp files deleting:"&DeleteFolder(File.DirApp&"\temp_update"))

End Sub

Private Sub DeleteFolder (folder As String) As Boolean
	If File.Exists(folder,"")=False Then Return False
	For Each f As String In File.ListFiles(folder)
		If File.IsDirectory(folder, f) Then
			DeleteFolder(File.Combine(folder, f))
		End If
		File.Delete(folder, f)
	Next
	Return File.Delete(folder, "")
End Sub
private Sub veriyoncoz(x As String)
	
	Try
		V1=0
		V2=0
		Dim com() As String
		com = Regex.Split("\.", x) 'returns: "abc", "def", "", "ghi"
		If IsNumber(com(0)) Then
			V1=com(0)
		Else
			V1=0
		End If
		If com.Length=2 Then
			If IsNumber(com(1)) Then
				V2=com(1)
			Else
				V2=0
			End If
		Else
			V2=0
		End If
	Catch
		AppLog(LastException)
		V1=0
		V2=0
	End Try
	
End Sub


private Sub webminor(x As String) As Int
	
	Try
		V1=0
		V2=0
		Dim com() As String
		com = Regex.Split("\.", x) 'returns: "abc", "def", "", "ghi"
		If IsNumber(com(0)) Then
			V1=com(0)
		Else
			V1=0
		End If
		If com.Length=2 Then
			If IsNumber(com(1)) Then
				V2=com(1)
			Else
				V2=0
			End If
		Else
			V2=0
		End If
	Catch
		AppLog(LastException)
		V1=0
		V2=0
	End Try
	Return V2
End Sub

private Sub webmajor(x As String) As Int
	
	Try
		V1=0
		V2=0
		Dim com() As String
		com = Regex.Split("\.", Target_Ver) 'returns: "abc", "def", "", "ghi"
		If IsNumber(com(0)) Then
			V1=com(0)
		Else
			V1=0
		End If
		If com.Length=2 Then
			If IsNumber(com(1)) Then
				V2=com(1)
			Else
				V2=0
			End If
		Else
			V2=0
		End If
	Catch
		AppLog(LastException)
		V1=0
		V2=0
	End Try
	Return V1
End Sub

Public Sub IsInitializedLAN As Boolean
	If Target_File.Trim= "" Then 
		AppLog("JAutoUpdate >> "&" Target file is empty")
		Return False
	End If
	
	If Target_Ext="" Then
		AppLog("JAutoUpdate >> "&" Extension file is empty")
		Return False
	End If
	If Folder_LAN="" Then
		AppLog("JAutoUpdate >> "&" Folder data is empty")
		Return False
	End If
	Return True
End Sub



Public Sub setFolderNameLAN(name As String)
	Folder_LAN=name.Trim.ToLowerCase
End Sub
Public Sub getFolderNameLAN As String
	Return Folder_LAN
End Sub


Public Sub setFolderNameWEB(name As String)
	Folder_WEB=name.Trim.ToLowerCase
End Sub
Public Sub getFolderNameWEB As String
	Return Folder_WEB
End Sub

Public Sub setTargetExtLAN(name As String)
	Target_Ext=name.Trim.ToLowerCase
End Sub
Public Sub getTargetExtLAN As String
	Return Target_Ext
End Sub

Public Sub setTargetFileLAN(name As String)
	Target_File=name.Trim.ToLowerCase
End Sub
Public Sub getTargetFileLAN As String
	Return Target_File
End Sub

'verisyon >> X.Y
'X:Main versiyon max limit << use it
'Y:Fraction max limit
Public Sub setVerisonLimit(MaxLimit As Int)
 MainLimit=MaxLimit
End Sub
'verisyon >> X.Y
'X:Main versiyon max limit << use it
'Y:Fraction max limit
Public Sub getVerisonLimit As Int
 Return MainLimit
End Sub

Public Sub setAppLogger(showlog As Boolean)
 Logger=showlog
End Sub
Public Sub getAppLogger As Boolean
 Return Logger
End Sub
'your applicationcurrent version.
Public Sub setAppVersion(version As String)
 Target_Ver=version
 veriyoncoz(Target_Ver)
End Sub
'your applicationcurrent version.
Public Sub getAppVersion As String
 Return Target_Ver
End Sub

'verisyon >> X.Y
'X:Main versiyon max limit
'Y:Fraction max limit << use it
Public Sub setVerFractionLimit(MaxLimit As Int)
	FractionLimit=MaxLimit
End Sub
'verisyon >> X.Y
'X:Main versiyon max limit
'Y:Fraction max limit << use it
Public Sub getVerFractionLimit As Int
	Return FractionLimit
End Sub

'Args(0)= Log =true/false
'Args(1)= aftermilisecond
'Args(2)=source file
'Args(3)=Target file
'Arg(4)=run jar filefile
'Arg(5)= package.main
'aftermilisecond : After works it form closed. its will copying from temp file after close app.
'RunJar: after copy action; your app automatic runs.
Public Sub FinishDownlaod(aftermilisecond As  Int,RunJar As Boolean,Package As String) As Boolean
	
	Dim shl As Shell
	'shl.Initialize("shl", "java", _
     'Array As String("-cp", "autoupdate.jar", "b4j.example.main", "http://www.basic4ppc.com"))
	'shl.Initialize("shl", "java.exe" , Array As String("-jar", "autoupdate.jar","LAN","old versiyon",tempfile))
	AppLog("Re-orgineze external app for finisihing process...")
	Dim x As List
	x.Initialize
	x.Add(True)
	x.Add(aftermilisecond)
	x.Add(File.DirApp&"\temp_update\"&Target_File&".tmp")
	x.Add(File.DirApp&"\"&Target_File&"."&Target_Ext)
	x.Add(RunJar)
	
	AppLog("autoupdate.jar")
	Dim dsy As String=(File.DirApp&"\temp_update\autoupdate.jar")
	AppLog("Dosyavar:" & File.Exists(dsy,"") )
	AppLog(File.DirApp&"\"&Target_File&"."&Target_Ext)
	AppLog((File.DirApp&"\temp_update\"&Target_File&".tmp"))  
	Try
		'shl.Initialize("shl", "java", Array As String("-cp", "sample.jar"))', "b4j.example.main", "http://www.basic4ppc.com"))
		shl.Initialize("shl", "java", Array As String("-cp", "autoupdate.jar","b4j.example.main",True,aftermilisecond,File.DirApp&"\temp_update\"&Target_File&".tmp",File.DirApp&"\"&Target_File&"."&Target_Ext,RunJar,Package))
		shl.WorkingDirectory = File.GetFileParent(dsy)
		shl.Run(10000) 
		AppLog("System action run")
		'set a timeout of 10 seconds
		'shl.Initialize("shl", "java.exe" , Array As String("-jar", "sample.jar"))
		'shl.Initialize("shl", "java.exe" , Array As String("-jar", "autoupdate.jar",True,aftermilisecond,File.DirApp&"\temp_update\"&Target_File&".tmp",File.DirApp&"\"&Target_File&"."&Target_Ext,RunJar))
		'shl.WorkingDirectory = File.GetFileParent(dsy)
		'shl.Run(1000) 'set a timeout of 10 seconds
	Catch
		Log(LastException)
		Return False	
	End Try
	
	AppLog("system runnig...")
	Return True
End Sub

Sub shl_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
	If Success And ExitCode = 0 Then
		AppLog("SHELL Success")
		AppLog(StdOut)
	Else
		AppLog("Shell Error: " & StdErr)
	End If
	'ExitApplication
End Sub

' start download process
'<code>
'Sub autoupdate_CheckingResult (Success As Boolean, updatetype As String)
'	If Success Then
'		If fx.Msgbox2(MainForm, "Do you want to download new version?", "Found new version", "Yes", "Cancel", "No",fx.MSGBOX_CONFIRMATION) = fx.DialogResponse.POSITIVE Then
'			Log("starting download... ")
'			
'			Select updatetype
'				Case "FTP"
'					autoupdate.StartDownlaodFTP
'				Case "LAN"
'					autoupdate.StartDownlaodLAN
'				Case "WEB"
'					autoupdate.StartDownlaodWEB
'				Case Else
'					Log("ERROR")
'			End Select
'		End If
'	Else
'		Log("No new verisyon...")
'	End If
'End Sub
'</code>
Public Sub StartDownlaodLan
	Try
		Dim xui As XUI
		File.MakeDir(File.DirApp,"temp_update")
		Wait For (File.CopyAsync(File.DirAssets, "autoupdate.jar", File.DirApp&"\temp_update", "autoupdate.jar")) Complete (Success As Boolean)
	
		If Success Then
			Wait For (File.CopyAsync(Folder_LAN, Real_File, File.DirApp&"\temp_update", Target_File&".tmpd")) Complete (Success As Boolean)
			If Success Then
				RenameTo(File.DirApp&"\temp_update", Target_File&".tmpd",File.DirApp&"\temp_update", Target_File&".tmp")
				
				Dim TempFolder As String=File.DirApp&"\temp_update"
				Dim TempFile As String=Target_File&".tmp"
				isDownloadComplete=True
				If xui.SubExists(mCallBack, mEventName & "_DownloadComplete",0) Then
					CallSubDelayed3(mCallBack,mEventName & "_DownloadComplete",TempFolder,TempFile)
				End If
			Else
				isDownloadComplete=False
				If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
					CallSubDelayed2(mCallBack,mEventName & "_DownloadError","File not download, please try again")
				End If
			End If
		Else
			isDownloadComplete=False
			If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
				CallSubDelayed2(mCallBack,mEventName & "_DownloadError","Jautodownload lib. can not create downloader, please try again")
			End If
		End If
	Catch
		AppLog("Error StartDownloadLan:"&LastException)
		isDownloadComplete=False
		If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
			CallSubDelayed2(mCallBack,mEventName & "_DownloadError",LastException)
		End If
	End Try
	
End Sub

'its cheking folder on LAN
Public Sub CheckingLan
	Dim xui As XUI
	Try
		If File.IsDirectory(Folder_LAN,"") Then
			AppLog("diizin buldu")
			'AppLog("JAutoUpdate >> "&" Folder is LOST")
			Dim lst As List
			lst=File.ListFiles(Folder_LAN)
			If lst.IsInitialized Then
				If lst.Size>0 Then
					Dim FindFile As String=""
					For i=0 To lst.Size-1
						Dim s As String = lst.Get(i)
						AppLog("files name is in folder : "&s)
						If s.ToLowerCase.StartsWith(Target_File) And s.ToLowerCase.EndsWith(Target_Ext) Then
							FindFile=s.ToLowerCase.Trim
							Exit
						End If
					Next
					If FindFile.Trim="" Then
						AppLog("JAutoUpdate >> "&" app can't find same file name")
						If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
							CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
						End If
						Return
						
					Else
						If Target_Ver="" Then
							AppLog(FileLastModified(File.DirApp,""))
							AppLog(FileLastModified(Folder_LAN,FindFile))
							If FileLastModified(File.DirApp,"")<FileLastModified(Folder_LAN,FindFile) Then
								AppLog("New version was found")
								Real_File=FindFile
								If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
									CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",True,"LAN")
								End If
								Return
							Else
								AppLog("New version was not found")
								If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
									CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
								End If
								Return 
							End If
						Else
							'*/*/*/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//*
							AppLog("Version control")
							If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
								CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",VersionKontrol(Folder_LAN,FindFile),"LAN")
							End If
							Return
							
						End If


					End If
				Else
					AppLog("JAutoUpdate >> "&" Folder is empty")
					If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
						CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
					End If
					Return
				End If
			
			Else
				AppLog("JAutoUpdate >> "&" Reading problem for files in folder")
				If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
					CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
				End If
				Return
			End If
		
		Else
			'AppLog("saallama dizin")
			AppLog("JAutoUpdate >> "&" Folder is LOST")
			If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
				CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
			End If
			Return
		End If
	Catch
		AppLog(LastException)
		If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
			CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"LAN")
		End If
		Return
	End Try
	
End Sub

Private Sub AppLog(txt As String)
	If Logger Then Log("###>> "&txt)
End Sub


Private Sub VersionKontrol(dizin As String, Dosya As String) As Boolean
	Try
		AppLog("Verison Checking")
		Dim components() As String
		Dim dsy As String=Dosya.Replace("."&Target_Ext,"")
		components = Regex.Split("\_", dsy) 'returns: "abc", "def", "", "ghi"
		
		If components.Length<>2 Then Return False

		Dim s1,s2 As Int
		s1=0
		s2=0
		Dim com() As String
		com = Regex.Split("\.", components(1)) 'returns: "abc", "def", "", "ghi"
		If IsNumber(com(0)) Then
			s1=com(0)
		End If
		If com.Length=2 Then
			If IsNumber(com(1)) Then
				s2=com(1)
			End If
		End If
		If s1>V1 Then
			Real_File=Dosya
			Return True
		else If s1<V1 Then
			Return False
		Else
			If s2>V2 Then 
				Real_File=Dosya
				Return True 
			Else 
				Return False
			 End If
		End If
	Catch
		AppLog(LastException)
		Return False
	End Try
	
	
End Sub



'Version : (only number and point) Own app verision. Code find upper version on WEB destination, if You use empty; The program checks the file dates. It works if the file in the destination is newer.
'FileName: its file name on destination folder. it s not inculded file extension
'FileExtension: its need for cheking file name.
'SourceFolder : Source folder on web.
'Note: be careful, have big and small character sensitivity.
'<code>
''ftp://test.rebex.net/
''Username is "demo", password is "password"
''https://test.rebex.net/ for more information.
'autoupdate.Initialize(Me,"autoupdate")
'autoupdate.UseFTP(MainForm,"1.2","readme","txt","test.rebex.net","demo","password",21)
'</code>
Public Sub UseFTP (AnaForm As Form,	Version As String,FileName As String,FileExtension  As String,serverftp As String, serverfolder As String, user As String,psw As String,port As Int)
	mBase = AnaForm.RootPane
	Target_Ver=Version.ToLowerCase.Trim
	Target_File= FileName.Trim
	Target_Ext=FileExtension.Trim
	Folder_FTP=serverfolder.Trim
	FTPserver=serverftp
	FTPport=port
	FTPuser=user.Trim
	FTPpsw=psw.Trim
	veriyoncoz(Target_Ver)
	AppLog("Temp files deleting:"&DeleteFolder(File.DirApp&"\temp_update"))

End Sub


Private Sub FTP_DownloadCompleted (ServerPath As String, Success As Boolean)
	Log(ServerPath & ", Success=" & Success)
	Dim xui As XUI
	If Success Then
		Dim TempFolder As String=File.DirApp&"\temp_update"
		Dim TempFile As String=Target_File&".tmp"
		isDownloadComplete=True
		If xui.SubExists(mCallBack, mEventName & "_DownloadComplete",0) Then
			CallSubDelayed3(mCallBack,mEventName & "_DownloadComplete",TempFolder,TempFile)
		End If
	Else
		isDownloadComplete=False
		If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
			CallSubDelayed2(mCallBack,mEventName & "_DownloadError","File not download, please try again")
		End If
	End If
End Sub

Public Sub isInitalizedFTP As Boolean'(serverftp As String, user As String,psw As String,port As Int)
	FTP.Initialize("FTP", FTPserver, FTPport, FTPuser, FTPpsw)
	Log("Results:" & FTP.IsInitialized)
	FTP.PassiveMode=True
	If FTP.IsInitialized Then
		Return True
		'FTP.List("")
		'FTP.DownloadFile("wd52dg/data/indices/tele_index_nh", True, File.DirApp, "esempio.txt")
	End If
	Return False
End Sub


'<code>
'Sub autoupdate_CheckingResult (Success As Boolean, updatetype As String)
'	If Success Then
'		If fx.Msgbox2(MainForm, "Do you want to download new version?", "Found new version", "Yes", "Cancel", "No",fx.MSGBOX_CONFIRMATION) = fx.DialogResponse.POSITIVE Then
'			Log("starting download... ")
'			
'			Select updatetype
'				Case "FTP"
'					autoupdate.StartDownlaodFTP
'				Case "LAN"
'					autoupdate.StartDownlaodLAN
'				Case "WEB"
'					autoupdate.StartDownlaodWEB
'				Case Else
'					Log("ERROR")
'			End Select
'		End If
'	Else
'		Log("No new verisyon...")
'	End If
'End Sub
'</code>
Sub StartDownlaodFTP
	
	Try
		Dim xui As XUI
		File.MakeDir(File.DirApp,"temp_update")
		Wait For (File.CopyAsync(File.DirAssets, "autoupdate.jar", File.DirApp&"\temp_update", "autoupdate.jar")) Complete (Success As Boolean)

		If Success Then
			FTP.DownloadFile(Folder_FTP&"/"&Real_File,True, File.DirApp&"\temp_update",Target_File&".tmp")
		Else
			isDownloadComplete=False
			If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
				CallSubDelayed2(mCallBack,mEventName & "_DownloadError","Jautodownload lib. can not create downloader, please try again")
			End If
		End If
	Catch
		AppLog("Error StartDownloadWeb Process:"&LastException)
		isDownloadComplete=False
		If xui.SubExists(mCallBack, mEventName & "_DownloadError", 0) Then
			CallSubDelayed2(mCallBack,mEventName & "_DownloadError",LastException)
		End If
	End Try


End Sub


'it s cheking FTP connection with target web site
Public Sub CheckingFTP
	Dim xui As XUI
	Dim FindFile As String=""
	Dim ffdate As Long=0
	Try
		'Dim w As OkHttpClient
		If FTP.IsInitialized Then
			
			FTP.List(Folder_FTP&"/")
			Wait For FTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
				If Success Then
					Log("başarılı")
					
					For i=0 To Files.Length-1
						Dim s As String = Files(i).Name
						AppLog("files name is in folder : "&s)
						If s.ToLowerCase.StartsWith(Target_File) And s.ToLowerCase.EndsWith(Target_Ext) Then
							FindFile=s.ToLowerCase.Trim
							ffdate=Files(i).Timestamp
							Exit
					End If
				Next
					
					If FindFile.Trim="" Then
						AppLog("JAutoUpdate >> "&" app can't find same file name")
						If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
							CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"FTP")
						End If
					Else
						If Target_Ver="" Then
						AppLog(FileLastModified(File.DirApp,Target_File&"."&Target_Ext))
						If FileLastModified(File.DirApp,Target_File&"."&Target_Ext)<ffdate Then
								AppLog("New version was found")
								Real_File=FindFile
								If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
									CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",True,"FTP")
								End If
								Return
							Else
								AppLog("New version was not found")
								If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
									CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",True,"FTP")
								End If
								Return
							End If
						Else
							'*/*/*/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//**/*/*/*/*/*/*/*//*
							AppLog("Version control")
							If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
								CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",VersionKontrol(Folder_FTP,FindFile),"FTP")
							End If
							Return
						End If

					End If
					
					
				Else
				If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
					CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"FTP")
				End If
				End If
			Else
			If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
				CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"FTP")
			End If
		End If
	
	Catch
		AppLog(LastException)
		If xui.SubExists(mCallBack, mEventName & "_CheckingResult", 0) Then
			CallSubDelayed3(mCallBack,mEventName & "_CheckingResult",False,"FTP")
		End If
	End Try
	
End Sub

